package com.pms.ocp.biz;

import com.pms.ocp.model.dto.ModelPropertyVersionDemandDTO;
import com.pms.ocp.model.dto.ModelVersionDemandDTO;
import com.pms.ocp.model.entity.Model;
import com.pms.ocp.model.entity.ModelBaseVersion;
import com.pms.ocp.model.entity.ModelPropertyVersion;

import java.util.List;

/**
 * @Auther: wangjian
 * @Date: 2022/4/1 10:29
 * @Description:
 */
public interface BizModelDemandService {

    /**
     * 创建模型需求
     *
     * @param modelVersionDemandDTO
     * @return
     */
    Integer createModelDemand(ModelVersionDemandDTO modelVersionDemandDTO);


    /**
     * 创建模型属性
     *
     * @param modelPropertyVersionDemandDTO
     * @return
     */
    Integer createModelPropertyDemand(ModelPropertyVersionDemandDTO modelPropertyVersionDemandDTO);

    /**
     * 修改模型需求
     *
     * @param modelVersionDemandDTO
     * @return
     */
    Integer updateModelDemand(ModelVersionDemandDTO modelVersionDemandDTO);

    /**
     * 修改模型属性需求
     *
     * @param modelPropertyVersionDemandDTO
     * @return
     */
    Integer updateModelPropertyDemand(ModelPropertyVersionDemandDTO modelPropertyVersionDemandDTO);

    /**
     * 删除模型需求
     *
     * @param demandId
     * @param modelId
     * @return
     */
    Integer deleteModelDemand(String demandId, String modelId);

    /**
     * 删除模型属性需求
     *
     * @param demandId
     * @param modelId
     * @param proId
     * @return
     */
    Integer deleteModelPropertyDemand(String demandId, String modelId, String proId);

    /**
     * 获取模型需求
     *
     * @param
     * @return
     */
    List<ModelBaseVersion> getModelDemandList(String modelCode, String modelGroupCode, int currentPage, int pageSize);

    /**
     * 获取模型属性需求
     *
     * @param
     * @return
     */
    List<ModelPropertyVersion> getModelPropertyDemandList(String propId, String modelCode, int currentPage, int pageSize);

    /**
     * 获取模型需求
     *
     * @param objId
     * @param modelGroupCode
     * @return
     */
    Model getModelDemand(String objId, String modelGroupCode);

    /**
     * 获取模型属性需求
     *
     * @param objId
     * @param modelGroupCode
     * @return
     */
    Model getModelPropertyDemand(String objId, String modelGroupCode);

}
